unit Unit1;

interface

uses
  System.SysUtils,
  System.Classes,

  JS,
  Web,

  WEBLib.Graphics,
  WEBLib.Controls,
  WEBLib.Forms,
  WEBLib.Dialogs,
  Vcl.Controls,
  WEBLib.WebCtrls,
  Vcl.StdCtrls,
  WEBLib.StdCtrls;

type
  TForm1 = class(TWebForm)
    WebButton1: TWebButton;
    WebHTMLDiv1: TWebHTMLDiv;
    procedure WebFormCreate(Sender: TObject);
    procedure WebButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  tabExample: JSValue;

implementation

{$R *.dfm}

procedure TForm1.WebButton1Click(Sender: TObject);
var
  DataArray: TJSArray;
begin

  // Get yer JSON however you like
  DataArray := TJSArray(TJSJSON.parseObject(
    '['+
      '{"NAME":"Albet Einstein", "DOB":"1879-03-14", "ROLE":"Patent Office Worker", "POINTS":10},'+
      '{"NAME":"Marie Curie",    "DOB":"1867-11-07", "ROLE":"Chemist / Physicist",  "POINTS":20},'+
      '{"NAME":"Sigmund Freud",  "DOB":"1856-05-06", "ROLE":"Psychoanalyst",        "POINTS":5 }' +
    ']'
  ));

  asm
    this.tabExample.replaceData(DataArray);
  end;
end;

procedure TForm1.WebFormCreate(Sender: TObject);
begin

  // Define an empty table, attach it to the TWebHTML component that has an ElementID of 'tabExample'
  asm
    this.tabExample = new Tabulator("#tabExample", {
      layout: "fitColumns",
 	    columns: [
        {field: "NAME",   title: "Name",     minWidth: 100                   },
        {field: "DOB",    title: "Birthday", width:    125, resizable: false,
          formatter:"datetime", formatterParams:{inputFormat:"yyyy-MM-dd", outputFormat:"yyyy-MMM-dd", invalidPlaceholder:"(invalid date)" }},
        {field: "ROLE",   title: "Role",     minWidth: 100                   },
        {field: "POINTS", title: "Points",   width:     75, resizable: false }
      ]
    });
  end;

end;

end.